import cryptobox.plugins.base
import cryptobox.plugins.manage
from cryptobox.core.exceptions import *


class volume_props(cryptobox.plugins.base.CryptoBoxPlugin):

	pluginCapabilities = [ "volume" ]
	pluginVisibility = [ "volume" ]
	requestAuth = False
	rank = 30


	def doAction(self, **args):
		import os
		self.props_plugins = [e for e in cryptobox.plugins.manage.PluginManager(self.cbox, self.cbox.prefs["Locations"]["PluginDir"]).getPlugins() if "properties" in e.getVisibility()]
		## sort plugins by rank
		self.props_plugins.sort(cmp = self.__cmpPluginsRank)
		## set the name of the templates for every plugin
		loadString = ""
		for p in self.props_plugins:
			p.device = self.device
			plfname = os.path.join(p.pluginDir, str(p.doAction(**args)) + ".cs")
			loadString += "<?cs include:'%s' ?>" % plfname
		## this is a little bit ugly: as it is not possible, to load cs files via
		## 'linclude' (see clearsilver doc) if they use previously defined macros (see
		## clearsilver mailing list thread 'linclude file which calls a macro' - 27th
		## December 02005)
		## our workaround: define the appropriate "include" (not 'linclude') commands
		## as a hdf variable - then we can include it via 'evar'
		self.hdf[self.hdf_prefix + 'includePlugins'] = loadString
		return "volume_properties"
	

	def getStatus(self):
		return "TODO"
	

	def loadDataSet(self, hdf):
		"""override the parent's function
		we have to get the data from all included plugins"""
		for p in self.props_plugins:
			p.loadDataSet(hdf)
		## call our parent's method
		cryptobox.plugins.base.CryptoBoxPlugin.loadDataSet(self, hdf)


	def __cmpPluginsRank(self, p1, p2):
		order = p1.getRank() - p2.getRank()
		if order < 0:
			return -1
		elif order == 0:
			return 0
		else:
			return 1
